'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.default = function (CoreManager, Exports) {

  Exports.RelationOp = Exports.RemoveOp = Exports.AddUniqueOp = Exports.AddOp = Exports.IncrementOp = Exports.UnsetOp = Exports.SetOp = Exports.Op = undefined;

  var arrayContainsObject = (0, _include2.default)('./arrayContainsObject', CoreManager);
  var decode = (0, _include2.default)('./decode', CoreManager);
  var encode = (0, _include2.default)('./encode', CoreManager);
  var ParseObject = (0, _include2.default)('./ParseObject', CoreManager);
  var ParseRelation = (0, _include2.default)('./ParseRelation', CoreManager);
  var unique = (0, _include2.default)('./unique', CoreManager);

  Exports.opFromJSON = function (json) {
    if (!json || !json.__op) {
      return null;
    }
    switch (json.__op) {
      case 'Delete':
        return new UnsetOp();
      case 'Increment':
        return new IncrementOp(json.amount);
      case 'Add':
        return new AddOp(decode.default(json.objects));
      case 'AddUnique':
        return new AddUniqueOp(decode.default(json.objects));
      case 'Remove':
        return new RemoveOp(decode.default(json.objects));
      case 'AddRelation':
        var toAdd = decode.default(json.objects);
        if (!Array.isArray(toAdd)) {
          return new RelationOp([], []);
        }
        return new RelationOp(toAdd, []);
      case 'RemoveRelation':
        var toRemove = decode.default(json.objects);
        if (!Array.isArray(toRemove)) {
          return new RelationOp([], []);
        }
        return new RelationOp([], toRemove);
      case 'Batch':
        var toAdd = [];
        var toRemove = [];
        for (var i = 0; i < json.ops.length; i++) {
          if (json.ops[i].__op === 'AddRelation') {
            toAdd = toAdd.concat(decode.default(json.ops[i].objects));
          } else if (json.ops[i].__op === 'RemoveRelation') {
            toRemove = toRemove.concat(decode.default(json.ops[i].objects));
          }
        }
        return new RelationOp(toAdd, toRemove);
    }
    return null;
  };

  var Op = function () {
    function Op() {
      (0, _classCallCheck3.default)(this, Op);
    }

    (0, _createClass3.default)(Op, [{
      key: 'applyTo',

      // Empty parent class
      value: function () {}
    }, {
      key: 'mergeWith',
      value: function () {}
    }, {
      key: 'toJSON',
      value: function () {}
    }]);
    return Op;
  }();

  Exports.Op = Op;

  var SetOp = function (_Op) {
    (0, _inherits3.default)(SetOp, _Op);

    function SetOp(value) {
      (0, _classCallCheck3.default)(this, SetOp);

      var _this = (0, _possibleConstructorReturn3.default)(this, (SetOp.__proto__ || (0, _getPrototypeOf2.default)(SetOp)).call(this));

      _this._value = value;
      return _this;
    }

    (0, _createClass3.default)(SetOp, [{
      key: 'applyTo',
      value: function () {
        return this._value;
      }
    }, {
      key: 'mergeWith',
      value: function () {
        return new SetOp(this._value);
      }
    }, {
      key: 'toJSON',
      value: function () {
        return encode.default(this._value, false, true);
      }
    }]);
    return SetOp;
  }(Op);

  Exports.SetOp = SetOp;

  var UnsetOp = function (_Op2) {
    (0, _inherits3.default)(UnsetOp, _Op2);

    function UnsetOp() {
      (0, _classCallCheck3.default)(this, UnsetOp);
      return (0, _possibleConstructorReturn3.default)(this, (UnsetOp.__proto__ || (0, _getPrototypeOf2.default)(UnsetOp)).apply(this, arguments));
    }

    (0, _createClass3.default)(UnsetOp, [{
      key: 'applyTo',
      value: function () {
        return undefined;
      }
    }, {
      key: 'mergeWith',
      value: function () {
        return new UnsetOp();
      }
    }, {
      key: 'toJSON',
      value: function () {
        return { __op: 'Delete' };
      }
    }]);
    return UnsetOp;
  }(Op);

  Exports.UnsetOp = UnsetOp;

  var IncrementOp = function (_Op3) {
    (0, _inherits3.default)(IncrementOp, _Op3);

    function IncrementOp(amount) {
      (0, _classCallCheck3.default)(this, IncrementOp);

      var _this3 = (0, _possibleConstructorReturn3.default)(this, (IncrementOp.__proto__ || (0, _getPrototypeOf2.default)(IncrementOp)).call(this));

      if (typeof amount !== 'number') {
        throw new TypeError('Increment Op must be initialized with a numeric amount.');
      }
      _this3._amount = amount;
      return _this3;
    }

    (0, _createClass3.default)(IncrementOp, [{
      key: 'applyTo',
      value: function (value) {
        if (typeof value === 'undefined') {
          return this._amount;
        }
        if (typeof value !== 'number') {
          throw new TypeError('Cannot increment a non-numeric value.');
        }
        return this._amount + value;
      }
    }, {
      key: 'mergeWith',
      value: function (previous) {
        if (!previous) {
          return this;
        }
        if (previous instanceof SetOp) {
          return new SetOp(this.applyTo(previous._value));
        }
        if (previous instanceof UnsetOp) {
          return new SetOp(this._amount);
        }
        if (previous instanceof IncrementOp) {
          return new IncrementOp(this.applyTo(previous._amount));
        }
        throw new Error('Cannot merge Increment Op with the previous Op');
      }
    }, {
      key: 'toJSON',
      value: function () {
        return { __op: 'Increment', amount: this._amount };
      }
    }]);
    return IncrementOp;
  }(Op);

  Exports.IncrementOp = IncrementOp;

  var AddOp = function (_Op4) {
    (0, _inherits3.default)(AddOp, _Op4);

    function AddOp(value) {
      (0, _classCallCheck3.default)(this, AddOp);

      var _this4 = (0, _possibleConstructorReturn3.default)(this, (AddOp.__proto__ || (0, _getPrototypeOf2.default)(AddOp)).call(this));

      _this4._value = Array.isArray(value) ? value : [value];
      return _this4;
    }

    (0, _createClass3.default)(AddOp, [{
      key: 'applyTo',
      value: function (value) {
        if (value == null) {
          return this._value;
        }
        if (Array.isArray(value)) {
          return value.concat(this._value);
        }
        throw new Error('Cannot add elements to a non-array value');
      }
    }, {
      key: 'mergeWith',
      value: function (previous) {
        if (!previous) {
          return this;
        }
        if (previous instanceof SetOp) {
          return new SetOp(this.applyTo(previous._value));
        }
        if (previous instanceof UnsetOp) {
          return new SetOp(this._value);
        }
        if (previous instanceof AddOp) {
          return new AddOp(this.applyTo(previous._value));
        }
        throw new Error('Cannot merge Add Op with the previous Op');
      }
    }, {
      key: 'toJSON',
      value: function () {
        return { __op: 'Add', objects: encode.default(this._value, false, true) };
      }
    }]);
    return AddOp;
  }(Op);

  Exports.AddOp = AddOp;

  var AddUniqueOp = function (_Op5) {
    (0, _inherits3.default)(AddUniqueOp, _Op5);

    function AddUniqueOp(value) {
      (0, _classCallCheck3.default)(this, AddUniqueOp);

      var _this5 = (0, _possibleConstructorReturn3.default)(this, (AddUniqueOp.__proto__ || (0, _getPrototypeOf2.default)(AddUniqueOp)).call(this));

      _this5._value = unique.default(Array.isArray(value) ? value : [value]);
      return _this5;
    }

    (0, _createClass3.default)(AddUniqueOp, [{
      key: 'applyTo',
      value: function (value) {
        if (value == null) {
          return this._value || [];
        }
        if (Array.isArray(value)) {
          // copying value lets Flow guarantee the pointer isn't modified elsewhere
          var valueCopy = value;
          var toAdd = [];
          this._value.forEach(function (v) {
            if (v instanceof ParseObject.default) {
              if (!arrayContainsObject.default(valueCopy, v)) {
                toAdd.push(v);
              }
            } else {
              if (valueCopy.indexOf(v) < 0) {
                toAdd.push(v);
              }
            }
          });
          return value.concat(toAdd);
        }
        throw new Error('Cannot add elements to a non-array value');
      }
    }, {
      key: 'mergeWith',
      value: function (previous) {
        if (!previous) {
          return this;
        }
        if (previous instanceof SetOp) {
          return new SetOp(this.applyTo(previous._value));
        }
        if (previous instanceof UnsetOp) {
          return new SetOp(this._value);
        }
        if (previous instanceof AddUniqueOp) {
          return new AddUniqueOp(this.applyTo(previous._value));
        }
        throw new Error('Cannot merge AddUnique Op with the previous Op');
      }
    }, {
      key: 'toJSON',
      value: function () {
        return { __op: 'AddUnique', objects: encode.default(this._value, false, true) };
      }
    }]);
    return AddUniqueOp;
  }(Op);

  Exports.AddUniqueOp = AddUniqueOp;

  var RemoveOp = function (_Op6) {
    (0, _inherits3.default)(RemoveOp, _Op6);

    function RemoveOp(value) {
      (0, _classCallCheck3.default)(this, RemoveOp);

      var _this6 = (0, _possibleConstructorReturn3.default)(this, (RemoveOp.__proto__ || (0, _getPrototypeOf2.default)(RemoveOp)).call(this));

      _this6._value = unique.default(Array.isArray(value) ? value : [value]);
      return _this6;
    }

    (0, _createClass3.default)(RemoveOp, [{
      key: 'applyTo',
      value: function (value) {
        if (value == null) {
          return [];
        }
        if (Array.isArray(value)) {
          var i = value.indexOf(this._value);
          var removed = value.concat([]);
          for (var i = 0; i < this._value.length; i++) {
            var index = removed.indexOf(this._value[i]);
            while (index > -1) {
              removed.splice(index, 1);
              index = removed.indexOf(this._value[i]);
            }
            if (this._value[i] instanceof ParseObject.default && this._value[i].id) {
              for (var j = 0; j < removed.length; j++) {
                if (removed[j] instanceof ParseObject.default && this._value[i].id === removed[j].id) {
                  removed.splice(j, 1);
                  j--;
                }
              }
            }
          }
          return removed;
        }
        throw new Error('Cannot remove elements from a non-array value');
      }
    }, {
      key: 'mergeWith',
      value: function (previous) {
        if (!previous) {
          return this;
        }
        if (previous instanceof SetOp) {
          return new SetOp(this.applyTo(previous._value));
        }
        if (previous instanceof UnsetOp) {
          return new UnsetOp();
        }
        if (previous instanceof RemoveOp) {
          var uniques = previous._value.concat([]);
          for (var i = 0; i < this._value.length; i++) {
            if (this._value[i] instanceof ParseObject.default) {
              if (!arrayContainsObject.default(uniques, this._value[i])) {
                uniques.push(this._value[i]);
              }
            } else {
              if (uniques.indexOf(this._value[i]) < 0) {
                uniques.push(this._value[i]);
              }
            }
          }
          return new RemoveOp(uniques);
        }
        throw new Error('Cannot merge Remove Op with the previous Op');
      }
    }, {
      key: 'toJSON',
      value: function () {
        return { __op: 'Remove', objects: encode.default(this._value, false, true) };
      }
    }]);
    return RemoveOp;
  }(Op);

  Exports.RemoveOp = RemoveOp;

  var RelationOp = function (_Op7) {
    (0, _inherits3.default)(RelationOp, _Op7);

    function RelationOp(adds, removes) {
      (0, _classCallCheck3.default)(this, RelationOp);

      var _this7 = (0, _possibleConstructorReturn3.default)(this, (RelationOp.__proto__ || (0, _getPrototypeOf2.default)(RelationOp)).call(this));

      _this7._targetClassName = null;

      if (Array.isArray(adds)) {
        _this7.relationsToAdd = unique.default(adds.map(_this7._extractId, _this7));
      }

      if (Array.isArray(removes)) {
        _this7.relationsToRemove = unique.default(removes.map(_this7._extractId, _this7));
      }
      return _this7;
    }

    (0, _createClass3.default)(RelationOp, [{
      key: '_extractId',
      value: function (obj) {
        if (typeof obj === 'string') {
          return obj;
        }
        if (!obj.id) {
          throw new Error('You cannot add or remove an unsaved Parse Object from a relation');
        }
        if (!this._targetClassName) {
          this._targetClassName = obj.className;
        }
        if (this._targetClassName !== obj.className) {
          throw new Error('Tried to create a Relation with 2 different object types: ' + this._targetClassName + ' and ' + obj.className + '.');
        }
        return obj.id;
      }
    }, {
      key: 'applyTo',
      value: function (value, object, key) {
        if (!value) {
          if (!object || !key) {
            throw new Error('Cannot apply a RelationOp without either a previous value, or an object and a key');
          }
          var parent = new ParseObject.default(object.className);
          if (object.id && object.id.indexOf('local') === 0) {
            parent._localId = object.id;
          } else if (object.id) {
            parent.id = object.id;
          }
          var relation = new ParseRelation.default(parent, key);
          relation.targetClassName = this._targetClassName;
          return relation;
        }
        if (value instanceof ParseRelation.default) {
          if (this._targetClassName) {
            if (value.targetClassName) {
              if (this._targetClassName !== value.targetClassName) {
                throw new Error('Related object must be a ' + value.targetClassName + ', but a ' + this._targetClassName + ' was passed in.');
              }
            } else {
              value.targetClassName = this._targetClassName;
            }
          }
          return value;
        } else {
          throw new Error('Relation cannot be applied to a non-relation field');
        }
      }
    }, {
      key: 'mergeWith',
      value: function (previous) {
        if (!previous) {
          return this;
        } else if (previous instanceof UnsetOp) {
          throw new Error('You cannot modify a relation after deleting it.');
        } else if (previous instanceof RelationOp) {
          if (previous._targetClassName && previous._targetClassName !== this._targetClassName) {
            throw new Error('Related object must be of class ' + previous._targetClassName + ', but ' + (this._targetClassName || 'null') + ' was passed in.');
          }
          var newAdd = previous.relationsToAdd.concat([]);
          this.relationsToRemove.forEach(function (r) {
            var index = newAdd.indexOf(r);
            if (index > -1) {
              newAdd.splice(index, 1);
            }
          });
          this.relationsToAdd.forEach(function (r) {
            var index = newAdd.indexOf(r);
            if (index < 0) {
              newAdd.push(r);
            }
          });

          var newRemove = previous.relationsToRemove.concat([]);
          this.relationsToAdd.forEach(function (r) {
            var index = newRemove.indexOf(r);
            if (index > -1) {
              newRemove.splice(index, 1);
            }
          });
          this.relationsToRemove.forEach(function (r) {
            var index = newRemove.indexOf(r);
            if (index < 0) {
              newRemove.push(r);
            }
          });

          var newRelation = new RelationOp(newAdd, newRemove);
          newRelation._targetClassName = this._targetClassName;
          return newRelation;
        }
        throw new Error('Cannot merge Relation Op with the previous Op');
      }
    }, {
      key: 'toJSON',
      value: function () {
        var _this8 = this;

        var idToPointer = function (id) {
          return {
            __type: 'Pointer',
            className: _this8._targetClassName,
            objectId: id
          };
        };

        var adds = null;
        var removes = null;
        var pointers = null;

        if (this.relationsToAdd.length > 0) {
          pointers = this.relationsToAdd.map(idToPointer);
          adds = { __op: 'AddRelation', objects: pointers };
        }
        if (this.relationsToRemove.length > 0) {
          pointers = this.relationsToRemove.map(idToPointer);
          removes = { __op: 'RemoveRelation', objects: pointers };
        }

        if (adds && removes) {
          return { __op: 'Batch', ops: [adds, removes] };
        }

        return adds || removes || {};
      }
    }]);
    return RelationOp;
  }(Op);

  Exports.RelationOp = RelationOp;
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}