'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = function (CoreManager, Exports) {

  Exports.default = function (obj) {
    if (!(obj instanceof ParseObject.default)) {
      return true;
    }
    var attributes = obj.attributes;
    for (var attr in attributes) {
      var val = attributes[attr];
      if (!canBeSerializedHelper(val)) {
        return false;
      }
    }
    return true;
  };

  var ParseFile = (0, _include2.default)('./ParseFile', CoreManager);
  var ParseObject = (0, _include2.default)('./ParseObject', CoreManager);
  var ParseRelation = (0, _include2.default)('./ParseRelation', CoreManager);

  function canBeSerializedHelper(value) {
    if ((typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) !== 'object') {
      return true;
    }
    if (value instanceof ParseRelation.default) {
      return true;
    }
    if (value instanceof ParseObject.default) {
      return !!value.id;
    }
    if (value instanceof ParseFile.default) {
      if (value.url()) {
        return true;
      }
      return false;
    }
    if (Array.isArray(value)) {
      for (var i = 0; i < value.length; i++) {
        if (!canBeSerializedHelper(value[i])) {
          return false;
        }
      }
      return true;
    }
    for (var k in value) {
      if (!canBeSerializedHelper(value[k])) {
        return false;
      }
    }
    return true;
  }
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}