'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = function (CoreManager, Exports) {

  Exports.default = equals;

  var ParseACL = (0, _include2.default)('./ParseACL', CoreManager);
  var ParseFile = (0, _include2.default)('./ParseFile', CoreManager);
  var ParseGeoPoint = (0, _include2.default)('./ParseGeoPoint', CoreManager);
  var ParseObject = (0, _include2.default)('./ParseObject', CoreManager);

  function equals(a, b) {
    if ((typeof a === 'undefined' ? 'undefined' : (0, _typeof3.default)(a)) !== (typeof b === 'undefined' ? 'undefined' : (0, _typeof3.default)(b))) {
      return false;
    }

    if (!a || (typeof a === 'undefined' ? 'undefined' : (0, _typeof3.default)(a)) !== 'object') {
      // a is a primitive
      return a === b;
    }

    if (Array.isArray(a) || Array.isArray(b)) {
      if (!Array.isArray(a) || !Array.isArray(b)) {
        return false;
      }
      if (a.length !== b.length) {
        return false;
      }
      for (var i = a.length; i--;) {
        if (!equals(a[i], b[i])) {
          return false;
        }
      }
      return true;
    }

    if (a instanceof ParseACL.default || a instanceof ParseFile.default || a instanceof ParseGeoPoint.default || a instanceof ParseObject.default) {
      return a.equals(b);
    }

    if ((0, _keys2.default)(a).length !== (0, _keys2.default)(b).length) {
      return false;
    }
    for (var k in a) {
      if (!equals(a[k], b[k])) {
        return false;
      }
    }
    return true;
  }
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}