'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = function (CoreManager, Exports) {

  var ParsePromise = (0, _include2.default)('./ParsePromise', CoreManager);
  var Storage = (0, _include2.default)('./Storage', CoreManager);

  var iidCache = null;

  function hexOctet() {
    return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
  }

  function generateId() {
    return hexOctet() + hexOctet() + '-' + hexOctet() + '-' + hexOctet() + '-' + hexOctet() + '-' + hexOctet() + hexOctet() + hexOctet();
  }

  (0, _assign2.default)(Exports, {
    currentInstallationId: function () {
      if (typeof iidCache === 'string') {
        return ParsePromise.default.as(iidCache);
      }
      var path = Storage.generatePath('installationId');
      return Storage.getItemAsync(path).then(function (iid) {
        if (!iid) {
          iid = generateId();
          return Storage.setItemAsync(path, iid).then(function () {
            iidCache = iid;
            return iid;
          });
        }
        iidCache = iid;
        return iid;
      });
    },
    _clearCache: function () {
      iidCache = null;
    },
    _setInstallationIdCache: function (iid) {
      iidCache = iid;
    }
  });
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}