'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = function (CoreManager, Exports) {

  // When there is no native storage interface, we default to an in-memory map
  var memMap = {};


  (0, _assign2.default)(Exports, {
    async: 0,

    getItem: function (path) {
      if (memMap.hasOwnProperty(path)) {
        return memMap[path];
      }
      return null;
    },
    setItem: function (path, value) {
      memMap[path] = String(value);
    },
    removeItem: function (path) {
      delete memMap[path];
    },
    clear: function () {
      for (var key in memMap) {
        if (memMap.hasOwnProperty(key)) {
          delete memMap[key];
        }
      }
    }
  });
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}