'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = function (CoreManager, Exports) {

  var ParsePromise = (0, _include2.default)('./ParsePromise', CoreManager);

  (0, _assign2.default)(Exports, {
    async: 1,

    getAsyncStorage: function () {
      return CoreManager.getAsyncStorage();
    },
    getItemAsync: function (path) {
      var p = new ParsePromise.default();
      this.getAsyncStorage().getItem(path, function (err, value) {
        if (err) {
          p.reject(err);
        } else {
          p.resolve(value);
        }
      });
      return p;
    },
    setItemAsync: function (path, value) {
      var p = new ParsePromise.default();
      this.getAsyncStorage().setItem(path, value, function (err) {
        if (err) {
          p.reject(err);
        } else {
          p.resolve(value);
        }
      });
      return p;
    },
    removeItemAsync: function (path) {
      var p = new ParsePromise.default();
      this.getAsyncStorage().removeItem(path, function (err) {
        if (err) {
          p.reject(err);
        } else {
          p.resolve();
        }
      });
      return p;
    },
    clear: function () {
      this.getAsyncStorage().clear();
    }
  });
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}