'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.default = function (CoreManager, Exports) {

  var ParsePromise = (0, _include2.default)('./ParsePromise', CoreManager);

  var TaskQueue = function () {
    function TaskQueue() {
      (0, _classCallCheck3.default)(this, TaskQueue);

      this.queue = [];
    }

    (0, _createClass3.default)(TaskQueue, [{
      key: 'enqueue',
      value: function (task) {
        var _this = this;

        var taskComplete = new ParsePromise.default();
        this.queue.push({
          task: task,
          _completion: taskComplete
        });
        if (this.queue.length === 1) {
          task().then(function () {
            _this._dequeue();
            taskComplete.resolve();
          }, function (error) {
            _this._dequeue();
            taskComplete.reject(error);
          });
        }
        return taskComplete;
      }
    }, {
      key: '_dequeue',
      value: function () {
        var _this2 = this;

        this.queue.shift();
        if (this.queue.length) {
          var next = this.queue[0];
          next.task().then(function () {
            _this2._dequeue();
            next._completion.resolve();
          }, function (error) {
            _this2._dequeue();
            next._completion.reject(error);
          });
        }
      }
    }]);
    return TaskQueue;
  }();

  Exports.default = TaskQueue;
};

var _include = require('./include');

var _include2 = _interopRequireDefault(_include);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}