'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

exports.default = function (modulePath, CoreManager) {
    var lowerModulePath = _path2.default.resolve(modulePath).toLowerCase();

    var coreManagerMap = void 0;
    if (moduleMap.has(lowerModulePath)) {
        coreManagerMap = moduleMap.get(lowerModulePath);
    } else {
        coreManagerMap = new _map2.default();
        moduleMap.set(lowerModulePath, coreManagerMap);
    }

    if (coreManagerMap.has(CoreManager)) return coreManagerMap.get(CoreManager);

    var Exports = {};
    coreManagerMap.set(CoreManager, Exports);

    var makeFunc = require(modulePath).default;
    makeFunc(CoreManager, Exports);

    return Exports;
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
}

var moduleMap = new _map2.default();