

import path from 'path';

const moduleMap = new Map();
export default function (modulePath, CoreManager) {
    const lowerModulePath = path.resolve(modulePath).toLowerCase();

    let coreManagerMap;
    if (moduleMap.has(lowerModulePath)) {
        coreManagerMap = moduleMap.get(lowerModulePath);
    } else {
        coreManagerMap = new Map();
        moduleMap.set(lowerModulePath, coreManagerMap);
    }

    if (coreManagerMap.has(CoreManager)) return coreManagerMap.get(CoreManager);

    let Exports = {};
    coreManagerMap.set(CoreManager, Exports);

    const makeFunc = require(modulePath).default;
    makeFunc(CoreManager, Exports);

    return Exports;
}